#ifndef GENERATEUR
#define GENERATEUR

#include "..\C-Engine\CEngine.hpp"

class MonsterPattern
{
    public:

    MonsterPattern(char * vtag , Animation * vanim, int  vanimnb, int vfreq, int vmax, int vidscript);

    char * tag;
    Animation * anim;
    int nbanim;
    int freq;
    int max;
    int idscript;
};

class Generateur: public Script
{
    public:

    Generateur();

    void SetBox(int x1 , int x2 , int y1 , int y2);
    void SetTab( int nbmonstre , MonsterPattern * tabpattern);

    void Update();
    void UpdateEverySecond();

    int CheckNbMonster( int id);
    void UpdateTimer(int id);
    void CreateMonster( int id);

    void ShowBox();

    int RandX();
    int RandY();

    private:

    int M_nombre;   //Le nombre de monstres gr par le gnrateur.
    char** M_Tag; // Un tableau qui contient le tag de tout les monstres.
    Animation ** M_Anim; // Tableau des diffrents animations.
    int * M_Anim_nb; //Tableau qui contient le nombre d'animation par pointeur d'animation
    int * M_Max; //tableau du nombre max de monstre dans la zone.
    int * M_Frequence; // frequence d'apparition des monstres par minute > 0
    int * M_Couldown; // tableau ncessaire pour stocker le temps.
    int * M_Id_Script; //Tableau qui contient le numro du script qui doit tre executer.

    bool active;
    bool show;
};

#endif // GQGUI

